"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
});
const _setupTrackingContext = _interopRequireDefault(require("./lib/setupTrackingContext")), _processTailwindFeatures = _interopRequireDefault(require("./processTailwindFeatures")), _sharedState = require("./lib/sharedState"), _findAtConfigPath = require("./lib/findAtConfigPath");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
module.exports = function(configOrPath) {
    return {
        postcssPlugin: "tailwindcss",
        plugins: [
            _sharedState.env.DEBUG && function(root) {
                return console.log("\n"), console.time("JIT TOTAL"), root;
            },
            function(root, result) {
                var _findAtConfigPath1;
                configOrPath = null !== (_findAtConfigPath1 = (0, _findAtConfigPath.findAtConfigPath)(root, result)) && void 0 !== _findAtConfigPath1 ? _findAtConfigPath1 : configOrPath;
                let context = (0, _setupTrackingContext.default)(configOrPath);
                if ("document" === root.type) {
                    for (let root1 of root.nodes.filter((node)=>"root" === node.type))"root" === root1.type && (0, _processTailwindFeatures.default)(context)(root1, result);
                    return;
                }
                (0, _processTailwindFeatures.default)(context)(root, result);
            },
            function lightningCssPlugin(_root, result) {
                let postcss = require("postcss"), lightningcss = require("lightningcss"), browserslist = require("browserslist");
                try {
                    var _result_map;
                    let transformed = lightningcss.transform({
                        filename: result.opts.from,
                        code: Buffer.from(result.root.toString()),
                        minify: !1,
                        sourceMap: !!result.map,
                        inputSourceMap: result.map ? result.map.toString() : void 0,
                        targets: "undefined" != typeof process && process.env.JEST_WORKER_ID ? {
                            chrome: 6946816
                        } : lightningcss.browserslistToTargets(browserslist(require("../package.json").browserslist)),
                        drafts: {
                            nesting: !0,
                            customMedia: !0
                        }
                    });
                    result.map = Object.assign(null !== (_result_map = result.map) && void 0 !== _result_map ? _result_map : {}, {
                        toJSON: ()=>transformed.map.toJSON(),
                        toString: ()=>transformed.map.toString()
                    }), result.root = postcss.parse(transformed.code.toString("utf8"));
                } catch (err) {
                    if ("undefined" != typeof process && process.env.JEST_WORKER_ID) {
                        let lines = err.source.split("\n");
                        err = Error([
                            "Error formatting using Lightning CSS:",
                            "",
                            "```css",
                            ...lines.slice(Math.max(err.loc.line - 3, 0), err.loc.line),
                            " ".repeat(err.loc.column - 1) + "^-- " + err.toString(),
                            ...lines.slice(err.loc.line, err.loc.line + 2),
                            "```"
                        ].join("\n"));
                    }
                    throw Error.captureStackTrace && Error.captureStackTrace(err, lightningCssPlugin), err;
                }
            },
            _sharedState.env.DEBUG && function(root) {
                return console.timeEnd("JIT TOTAL"), console.log("\n"), root;
            }
        ].filter(Boolean)
    };
}, module.exports.postcss = !0;
